#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf portmap-6.0.tgz
    cd portmap_6.0
    for SRCFILE in pmap_check.[ch]; do
	ed -s $SRCFILE >/dev/null <<EOF
1,\$s/__attribute_* ((visibility ("hidden")))//
w
q
EOF
    done
    make FACILITY=LOG_AUTHPRIV
    strip -R .note -R .comment portmap
    mkdir -p ../portmap/sbin
    cp portmap ../portmap/sbin/
    cd ..
    rm -rf portmap_6.0
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/.. 
done
